package com.vendor.loader.views;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.model.devices.unknown.UnknownDevice;
import com.vendor.burn.utilitily.ToolUtils;
import com.vendor.burn.views.FastbootView;
import com.vendor.loader.Activator;
import com.vendor.loader.Log.Log;
import com.vendor.loader.Messages;
import com.vendor.loader.controler.GlobleControler;
import com.vendor.loader.struct.ssu.SsuConstants;
import com.vendor.loader.ui.ControlFactory;
import com.vendor.loader.ui.LoaderComposite;
import com.vendor.loader.ui.ssu.SsuALoaderComposite;
import com.vendor.loader.ui.ssu.SsuLoaderComposite;
import com.vendor.platform.api.IDeviceChangedListener;
import com.vendor.platform.api.IDeviceManager;
import com.vendor.platform.api.chips.Chip;
import java.awt.Toolkit;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.ControlListener;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.ui.IPerspectiveDescriptor;
import org.eclipse.ui.IPerspectiveListener4;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPartReference;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.part.ViewPart;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

public class LoaderView extends ViewPart implements IDeviceChangedListener, IPerspectiveListener4, ControlListener {
  public static final String ID = com.vendor.loader.views.LoaderView.class.getName();
  
  private LoaderComposite composite;
  
  private SsuLoaderComposite ssuComposite;
  
  private SsuALoaderComposite ssuaComposite;
  
  private StackLayout stackLayout;
  
  private Composite comp;
  
  private FormToolkit toolkit;
  
  private ScrolledForm form;
  
  private ScrolledComposite scrolledComposite;
  
  private Composite parent;
  
  public static boolean isChipBranchSeries0() {
    String chipNameType = FastbootView.getCurrentChipNameType();
    if (chipNameType == null)
      return false; 
    if (chipNameType.equalsIgnoreCase("20") || chipNameType.equalsIgnoreCase("21") || chipNameType
      .equalsIgnoreCase("36"))
      return true; 
    return false;
  }
  
  public static boolean isChipBranchSeries1() {
    String chipNameType = FastbootView.getCurrentChipNameType();
    if (chipNameType == null)
      return false; 
    if (chipNameType.equalsIgnoreCase("16") || chipNameType.equalsIgnoreCase("17") || chipNameType
      .equalsIgnoreCase("34"))
      return true; 
    return false;
  }
  
  public static boolean isChipBranchSeries2() {
    String chipNameType = FastbootView.getCurrentChipNameType();
    if (chipNameType == null)
      return false; 
    if (chipNameType.equalsIgnoreCase("16") || chipNameType.equalsIgnoreCase("17") || chipNameType
      .equalsIgnoreCase("22") || chipNameType.equalsIgnoreCase("20") || chipNameType
      .equalsIgnoreCase("21") || chipNameType.equalsIgnoreCase("36") || chipNameType
      .equalsIgnoreCase("34"))
      return true; 
    return false;
  }
  
  private int minHeight = 750;
  
  private int tablieHeight = 250;
  
  public static boolean isETSITS102006V141() {
    String chipNameType = FastbootView.getCurrentChipNameType();
    if (chipNameType == null)
      return false; 
    return (chipNameType.equalsIgnoreCase("23") || chipNameType.equalsIgnoreCase("22") || chipNameType
      .equalsIgnoreCase("36"));
  }
  
  public void createPartControl(Composite parent) {
    parent.addControlListener((ControlListener)new Object(this, parent));
    this.parent = parent;
    createControl();
  }
  
  public void deviceChanged() {
    if (this.parent != null && !this.parent.isDisposed()) {
      if (this.scrolledComposite != null && !this.scrolledComposite.isDisposed())
        this.scrolledComposite.dispose(); 
      createControl();
      this.parent.layout();
    } 
  }
  
  private void createControl() {
    this.scrolledComposite = new ScrolledComposite(this.parent, 2816);
    this.scrolledComposite.setBackground(SsuConstants.white);
    this.scrolledComposite.setExpandHorizontal(true);
    this.scrolledComposite.setExpandVertical(true);
    this.scrolledComposite.setMinWidth(1750);
    this.scrolledComposite.setMinHeight(1000);
    Composite pubComposite = new Composite((Composite)this.scrolledComposite, 0);
    pubComposite.setBackground(SsuConstants.white);
    pubComposite.setLayout((Layout)new FillLayout());
    this.scrolledComposite.setContent((Control)pubComposite);
    Composite rootArea = createViewContainer(pubComposite);
    Group selectProcolArea = ControlFactory.createGroup(rootArea, Messages.SelectProtocolDialog_SelectInformation, 3);
    this.comp = ControlFactory.createStackComposite(rootArea, 1808);
    this.stackLayout = (StackLayout)this.comp.getLayout();
    Object object1 = new Object(this);
    Object object2 = new Object(this);
    boolean isSOCTAndOad = false;
    String chipNameType = FastbootView.getCurrentChipNameType();
    if (chipNameType != null)
      isSOCTAndOad = (chipNameType.equalsIgnoreCase("20") || chipNameType.equalsIgnoreCase("21") || chipNameType.equalsIgnoreCase("23") || chipNameType.equalsIgnoreCase("22") || chipNameType.equalsIgnoreCase("36")); 
    if (isSOCTAndOad) {
      Button soct = ControlFactory.createRadioButton((Composite)selectProcolArea, "SOCT", "SOCT", (SelectionListener)object1);
      soct.setSelection(true);
      GlobleControler.intance.setProtocol(GlobleControler.Protocol.SOCT);
      this.composite = new LoaderComposite(this.comp, 0);
      this.comp.setData("SUPPORTTS", "NO");
      Object object = new Object(this);
      ControlFactory.createRadioButton((Composite)selectProcolArea, "OAD", "OAD", (SelectionListener)object);
      this.ssuaComposite = new SsuALoaderComposite(this.comp, 0);
    } else {
      Button soct = ControlFactory.createRadioButton((Composite)selectProcolArea, "SOCT", "SOCT", (SelectionListener)object1);
      Button ssu = ControlFactory.createRadioButton((Composite)selectProcolArea, "SSU", "SSU", (SelectionListener)object2);
      boolean result = GlobleControler.intance.isSOCT();
      if (result) {
        soct.setSelection(result);
        GlobleControler.intance.setProtocol(GlobleControler.Protocol.SOCT);
      } else {
        ssu.setSelection(!result);
        GlobleControler.intance.setProtocol(GlobleControler.Protocol.SSU);
      } 
      this.comp.setData("SUPPORTTS", "YES");
      this.composite = new LoaderComposite(this.comp, 0);
      this.ssuComposite = new SsuLoaderComposite(this.comp, 0);
      if (chipNameType != null && chipNameType.equalsIgnoreCase("17")) {
        Object object = new Object(this);
        ControlFactory.createRadioButton((Composite)selectProcolArea, "ETSI", "OAD", (SelectionListener)object);
        this.ssuaComposite = new SsuALoaderComposite(this.comp, 0);
      } 
    } 
    if (GlobleControler.Protocol.SOCT.equals(GlobleControler.intance.getProtocol())) {
      this.stackLayout.topControl = (Control)this.composite;
    } else if (GlobleControler.Protocol.SSU.equals(GlobleControler.intance.getProtocol())) {
      this.stackLayout.topControl = (Control)this.ssuComposite;
    } else if (GlobleControler.Protocol.SSUA.equals(GlobleControler.intance.getProtocol())) {
      this.stackLayout.topControl = (Control)this.ssuaComposite;
    } 
    ControlFactory.adaptComposit((Control)rootArea);
    this.toolkit.paintBordersFor(this.form.getBody());
  }
  
  protected Composite createViewContainer(Composite parent) {
    this.toolkit = new FormToolkit(parent.getDisplay());
    this.form = new ScrolledForm(parent, Window.getDefaultOrientation());
    this.form.setExpandHorizontal(true);
    this.form.setExpandVertical(true);
    this.form.setMinWidth(1750);
    this.form.setMinHeight(1000);
    int screenHeight = (Toolkit.getDefaultToolkit().getScreenSize()).height;
    if (screenHeight <= this.minHeight) {
      this.form.setMinHeight(1000);
    } else {
      this.form.setMinHeight(1000 + this.tablieHeight);
    } 
    this.form.setFont(JFaceResources.getHeaderFont());
    this.form.getBody().setLayout((Layout)new GridLayout());
    ControlFactory.setFormToolkit(this.toolkit);
    return this.form.getBody();
  }
  
  public void dispose() {
    this.toolkit.dispose();
    super.dispose();
  }
  
  public void setFocus() {
    this.parent.layout();
    ToolUtils.disableDetach(ID);
  }
  
  public void perspectiveOpened(IWorkbenchPage page, IPerspectiveDescriptor perspective) {
    ToolUtils.disableDetach(ID);
  }
  
  public void perspectiveClosed(IWorkbenchPage page, IPerspectiveDescriptor perspective) {}
  
  public void perspectiveDeactivated(IWorkbenchPage page, IPerspectiveDescriptor perspective) {}
  
  public void perspectiveSavedAs(IWorkbenchPage page, IPerspectiveDescriptor oldPerspective, IPerspectiveDescriptor newPerspective) {}
  
  public void perspectiveActivated(IWorkbenchPage page, IPerspectiveDescriptor perspective) {}
  
  public void perspectiveChanged(IWorkbenchPage page, IPerspectiveDescriptor perspective, String changeId) {}
  
  public void controlMoved(ControlEvent e) {}
  
  public void controlResized(ControlEvent e) {}
  
  public void perspectivePreDeactivate(IWorkbenchPage page, IPerspectiveDescriptor perspective) {}
  
  public void deviceChanged(Chip chip) {
    if (chip != null) {
      UnknownDevice ud = new UnknownDevice(chip.getName());
      if (!ud.isValid())
        Log.errorln("Unsupported device. LoaderToolCLI will not work for this device."); 
      GlobleControler.setBranchByChipNameType(ud.getChipNameType());
      deviceChanged();
    } 
  }
  
  public void init(IViewSite site) throws PartInitException {
    super.init(site);
    BundleContext bundleContext = Activator.getDefault().getBundle().getBundleContext();
    ServiceReference<?> sreference = bundleContext.getServiceReference(IDeviceManager.class);
    if (sreference == null)
      return; 
    IDeviceManager deviceManager = (IDeviceManager)bundleContext.getService(sreference);
    deviceManager.addDeviceChangedListener(this);
    String currentDevice = deviceManager.getCurrentDevice();
    if (currentDevice == null || currentDevice.trim().length() == 0)
      return; 
    UnknownDevice ud = new UnknownDevice(currentDevice);
    if (!ud.isValid())
      Log.errorln("Unsupported device. LoaderToolCLI will not work for this device."); 
    GlobleControler.setBranchByChipNameType(ud.getChipNameType());
  }
  
  public void perspectiveChanged(IWorkbenchPage page, IPerspectiveDescriptor perspective, IWorkbenchPartReference partRef, String changeId) {}
}
